diff a/src/hotspot/share/runtime/synchronizer.hpp b/src/hotspot/share/runtime/synchronizer.hpp
--- a/src/hotspot/share/runtime/synchronizer.hpp
+++ b/src/hotspot/share/runtime/synchronizer.hpp
@@ -242,17 +242,17 @@
  private:
   JavaThread* _thread;
   Handle      _obj;
   BasicLock   _lock;
   NoPreemptMark _npm;
+  bool    _skip_exit;
  public:
-  ObjectLocker(Handle obj, JavaThread* current);
+  ObjectLocker(Handle obj, TRAPS);
   ~ObjectLocker();
 
   // Monitor behavior
-  void wait(TRAPS)  { ObjectSynchronizer::wait(_obj, 0, CHECK); } // wait forever
-  void wait_uninterruptibly(TRAPS)  { ObjectSynchronizer::waitUninterruptibly(_obj, 0, CHECK); } // wait forever
+  void wait_uninterruptibly(TRAPS);
   void notify_all(TRAPS)  { ObjectSynchronizer::notifyall(_obj, CHECK); }
 };
 
 // Interface to visit monitors
 class ObjectMonitorsView {
